// Generated by CoffeeScript 1.9.3
var DICTIONARY_MATCHERS, GRAPHS, KEYBOARD_AVERAGE_DEGREE, KEYBOARD_STARTING_POSITIONS, KEYPAD_AVERAGE_DEGREE, KEYPAD_STARTING_POSITIONS, MATCHERS, calc_average_degree, k, loader, time, v, zxcvbn;

DICTIONARY_MATCHERS = [build_dict_matcher('passwords', build_ranked_dict(passwords)), build_dict_matcher('english', build_ranked_dict(english)), build_dict_matcher('male_names', build_ranked_dict(male_names)), build_dict_matcher('female_names', build_ranked_dict(female_names)), build_dict_matcher('surnames', build_ranked_dict(surnames))];

MATCHERS = DICTIONARY_MATCHERS.concat([l33t_match, digits_match, year_match, date_match, repeat_match, sequence_match, spatial_match]);

GRAPHS = {
  'qwerty': qwerty,
  'dvorak': dvorak,
  'keypad': keypad,
  'mac_keypad': mac_keypad
};

calc_average_degree = function(graph) {
  var average, k, key, n, neighbors, v;
  average = 0;
  for (key in graph) {
    neighbors = graph[key];
    average += ((function() {
      var i, len, results;
      results = [];
      for (i = 0, len = neighbors.length; i < len; i++) {
        n = neighbors[i];
        if (n) {
          results.push(n);
        }
      }
      return results;
    })()).length;
  }
  average /= ((function() {
    var results;
    results = [];
    for (k in graph) {
      v = graph[k];
      results.push(k);
    }
    return results;
  })()).length;
  return average;
};

KEYBOARD_AVERAGE_DEGREE = calc_average_degree(qwerty);

KEYPAD_AVERAGE_DEGREE = calc_average_degree(keypad);

KEYBOARD_STARTING_POSITIONS = ((function() {
  var results;
  results = [];
  for (k in qwerty) {
    v = qwerty[k];
    results.push(k);
  }
  return results;
})()).length;

KEYPAD_STARTING_POSITIONS = ((function() {
  var results;
  results = [];
  for (k in keypad) {
    v = keypad[k];
    results.push(k);
  }
  return results;
})()).length;

time = function() {
  return (new Date()).getTime();
};

zxcvbn = function(password, user_inputs) {
  var arg, i, len, matches, result, sanitized_inputs, start, user_inputs_matcher;
  if (user_inputs == null) {
    user_inputs = [];
  }
  start = time();
  sanitized_inputs = [];
  for (i = 0, len = user_inputs.length; i < len; i++) {
    arg = user_inputs[i];
    if (arg != null) {
      sanitized_inputs.push(arg.toString().toLowerCase());
    }
  }
  user_inputs_matcher = build_dict_matcher('user_inputs', build_ranked_dict(sanitized_inputs));
  matches = omnimatch(password, MATCHERS.concat(user_inputs_matcher));
  result = minimum_entropy_match_sequence(password, matches);
  result.calc_time = time() - start;
  return result;
};

loader = function(root, factory) {
  if (typeof define === 'function' && (define.amd != null)) {
    define([], factory);
  } else if (typeof module === 'object' && (module.exports != null)) {
    module.exports = factory();
  } else {
    root.zxcvbn = factory();
  }
  return typeof root.zxcvbn_load_hook === "function" ? root.zxcvbn_load_hook() : void 0;
};

loader(this, function() {
  return zxcvbn;
});
